<?php
/*
Copyright 2018	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/

// Variablen für zur Erzeugung der Datenbanktabellen

$create_kasse_usr="CREATE TABLE IF NOT EXISTS `kasse_usr` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`datum_anmeld` date NOT NULL,
			`datum_update` date NOT NULL,
			`vorname` varchar(50) CHARACTER SET utf8 NOT NULL,
			`nachname` varchar(50) CHARACTER SET utf8 NOT NULL,
			`mailadresse` varchar(50) CHARACTER SET utf8 NOT NULL,
			`aktiv` int(11) NOT NULL,
			`art` int(11) NOT NULL,
			`account` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
			`strasse` text COLLATE utf8_unicode_ci NOT NULL,
			`plz` text COLLATE utf8_unicode_ci NOT NULL,
			`ort` text COLLATE utf8_unicode_ci NOT NULL,
			PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";

$create_kasse_preise="CREATE TABLE IF NOT EXISTS `kasse_preise` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`p_id` int(11) NOT NULL,
			`account` varchar(50) NOT NULL,
			`artikel` varchar(50) NOT NULL,
			`preis` double NOT NULL,
			`a_druck` int(11) NOT NULL,
			`bemerkungen` text NOT NULL,
			PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

// 	36 Spalten für Buttons erzeugen
$button="";
for ($i=1; $i<37; $i++) {
	$button=$button . "`b" . $i . "` varchar(20) NOT NULL, `bf" . $i . "` varchar(10) NOT NULL,";
}

$create_kasse_kassen="CREATE TABLE IF NOT EXISTS `kasse_kassen` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`k_id` int(11) NOT NULL,
			`account` varchar(50) NOT NULL,
			`drucker` varchar(20) NOT NULL,
			`bemerkungen` varchar(50) NOT NULL, "
			. $button . " PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8";
			
$create_kasse_drucker="CREATE TABLE IF NOT EXISTS `kasse_drucker` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`d_id` int(11) NOT NULL,
			`typ` varchar(20) NOT NULL,
			`bart` varchar(20) NOT NULL COMMENT 'Betriebsart',
			`aart` varchar(20) NOT NULL COMMENT 'Anschlussart',
			`geraet` varchar(20) NOT NULL,
			`account` varchar(50) NOT NULL,
			`bonzeile1` varchar(50) NOT NULL,
			`bemerkungen` varchar(50) NOT NULL,
			PRIMARY KEY (`id`)
			) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$create_kasse_verkaeufer="CREATE TABLE IF NOT EXISTS `kasse_verkaeufer` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`account` varchar(50) NOT NULL,
			`kasse` int(11) NOT NULL,
			`vorname` varchar(50) NOT NULL,
			`nachname` varchar(50) NOT NULL,
			`strasse` varchar(50) NOT NULL,
			`plz` varchar(10) NOT NULL,
			`ort` varchar(50) NOT NULL,
			`verguetung` double NOT NULL,
			`wechselgeld` double NOT NULL,
			`bemerkungen` varchar(50) NOT NULL,
			PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$create_kasse_verkauf="CREATE TABLE IF NOT EXISTS `kasse_verkauf` (
			`v_id` int(11) NOT NULL AUTO_INCREMENT,
			`account` varchar(50) NOT NULL,
			`id_verkauf` int(11) NOT NULL,
			`id_artikel` int(11) NOT NULL,
			`datum` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			`verkaeufer` varchar(50) NOT NULL,
			`artikel` varchar(50) NOT NULL,
			`preis` double NOT NULL,
			`anzahl` int(11) NOT NULL,
			`tisch` int(11) NOT NULL,
			`kassiert` tinyint(4) NOT NULL,
			`abgerechnet` tinyint(4) NOT NULL COMMENT 'Verkäuferprovision',
			PRIMARY KEY (`v_id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$create_kasse_verkabrech="CREATE TABLE IF NOT EXISTS `kasse_verkabrech` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`Account` varchar(50) NOT NULL,
			`Abrechner` varchar(50) NOT NULL,
			`datum` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
			`Verkaeufer` varchar(50) NOT NULL,
			`ersteBuchung` datetime NOT NULL,
			`letzteBuchung` datetime NOT NULL,
			`Gesamtumsatz` double NOT NULL,
			`VerkaeuferSatz` int(11) NOT NULL,
			`VerkaeuferVerguet` double NOT NULL,
			`UmsatzVerein` double NOT NULL,
			`Wechselgeld` double NOT NULL,
			`VerkauferRueck` double NOT NULL,
			PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$create_kasse_wsdr="CREATE TABLE IF NOT EXISTS `kasse_wsdr` (
			`w_id` int(11) NOT NULL AUTO_INCREMENT,
			`drucker_id` int(11) NOT NULL,
			`verkauf_id` int(11) NOT NULL,
			`status` int(11) NOT NULL,
			`account` varchar(50) NOT NULL,
			PRIMARY KEY (`w_id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$create_kasse_stat="CREATE TABLE IF NOT EXISTS `kasse_stat` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`usr` int(11) NOT NULL,
			`datum` date NOT NULL,
			`anzahl` int(11) NOT NULL,
			PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";

?>