<?php
/*
Copyright 2018	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/
session_start();
include('../config.php');
include('../funktionen.php');
$link=db_verbinden($db_host, $db_name, $db_user, $db_pass);

htmlkopf();
sessioncheck1();
zeige_kopf('index');

echo "<div id='container'>";

function anzeigenDB() {
	global $link;
	echo "<p><h3>Datenbank exportieren</h3>
	 	<form method='post' action='verwaltung.php?sw=2'>
  		<input type='radio' name='export' value='Daten' checked> Daten Total<br>
  		<input type='radio' name='export' value='Struktur'> Tabellenstruktur und Daten Total
  		<input class='navig' type='submit' value='Export starten'>
		</form></p>";
	echo "<p><h3>Daten Verkauf</h3>
		<form method='post' action='verwaltung.php?sw=2'>
		<input type='hidden' size='3' name='export' value='Verkauf'>
		vom <input type='text' size='3' name='DatenVon' id='DatenVon'>
		bis <input type='text' size='3' name='DatenBis' id='DatenBis'/>
		<input class='navig' type='submit' value=' Export starten'></form>
		
		<script type='text/javascript' src='datepickr.js'></script>
		<script type='text/javascript'>
		new datepickr('DatenVon', { 'dateFormat': 'd.m.Y' });
		new datepickr('DatenBis', { 'dateFormat': 'd.m.Y' });
		</script></p>";
	
	echo "<br><br><p><h3>Datenbank importieren</h3>
		<form action='verwaltung.php?sw=3' method='post' enctype='multipart/form-data' />
		<input type='file' name='datei' /><br><br>
		<input type='radio' name='export' value='Struktur'> Tabellen löschen, Tabellenstruktur erstellen und Daten importieren<br>
		<input type='radio' name='export' value='Daten' checked> Daten Verkauf anhängen
		<input class='navig' type='submit' name='submit' value='Import starten' />
		</form>
		<br><br></p>";
}

function anzeigenUpd() {
	global $link;
	global $raapp_mode;
	
	echo "<br><br><br><div id='upd1'><h3>Auf Update prüfen<img src='images/raapp_ok.png' onload='laden_update(" . $_SESSION['version'] . ", $raapp_mode)'></h3></div>
	<div id='upd2' style='display:none'></div><br><br><br>";
}

function tabelleninhalt($tabelle, $post) {
	include("../conf_tables.php");
	global $link;
	$content="";
	
	// Spaltennamen Tabelle holen
	$abfrage="Show columns from " . $tabelle;
	$erg = mysqli_query($link, $abfrage);
	
	$i=0;
	while ( $mykasse=mysqli_fetch_object( $erg )) {
		$spalten[$i]=$mykasse->Field;
		$i++;
	}
	
	if(isset($post['DatenVon']) && $post['DatenVon'] != '') {
		// Formatierung Datum für Select Statement
		$von=format_datum($post['DatenVon'], '00:00:00');
		if($post['DatenBis'] == '') {
			// Sollte DatenBis keinen Wert enthalten wird davon ausgegangen, daß der gleiche Tag für von und bis zu verwenden ist
			$bis=format_datum($post['DatenVon'], '23:59:59');
		} else { 
			$bis=format_datum($post['DatenBis'], '23:59:59');
		}
		
		echo "Daten von $von bis $bis<br>";

		// Tabelle schreiben
		$abfrage="SELECT * FROM " . $tabelle . " where datum >= '" . $von . "' and datum <= '" . $bis . "'";
	} else {
		$abfrage="SELECT * FROM " . $tabelle;
	}

	$erg = mysqli_query($link, $abfrage);
	
	if($post['export'] == 'Struktur') {
		$create="create_" . $tabelle;
		$content.= $$create . ";\n\n";		// $$create nutzt den Inhalt von $create als variablenname
	}
	
	$content_tmp="LOCK TABLES `" . $tabelle . "` WRITE; \n\nINSERT INTO `" . $tabelle . "` VALUES ";
	$i=0;
	$s=0;
	
	while ( $mykasse=mysqli_fetch_object( $erg )) {
		if($i==0) {	$komma=""; } else { $komma=", "; } // beim ersten Datensatz kein Komma setzen
		$content_tmp.="$komma(";
		foreach($spalten as $spalte) {
			if($s==0) { $skomma=""; } else { $skomma=", "; } // bei der ersten Spalte kein Komma setzen
			$content_tmp.="$skomma '" . $mykasse->$spalte . "'";
			$s++;
		}
		$content_tmp.=")";
		$s=0;
		$i++;
	}
	$content_tmp.=";\n\nUNLOCK TABLES;";
	
	// Nur wenn Datensätze vorhanden sind wird Lock Tabels, Insert und UnlockTabels ausgegeben, geprüft über klammer auf (
	if(strpos($content_tmp, "(")) {
		$content.=$content_tmp;
	}
	
	return($content);
}

function sqlExport($post) {
	include("../config.php");
	global $link;
	
	echo "Datenbank wird gesichert<br><br>";
	$filename=$_SERVER['DOCUMENT_ROOT'] . DIRECTORY_SEPARATOR . "raapp" . DIRECTORY_SEPARATOR .  "db_export" . DIRECTORY_SEPARATOR . strftime('%Y-%m-%d_') . $db_name . "_kasse.sql";
	$content="-- raAPP Kasse\n\n";
	
	switch ($post['export']) {
		case 'Verkauf':	$content.=tabelleninhalt('kasse_verkauf', $post) . "\n\n";
						echo "Tabelle kasse_verkauf wurde exportiert<br>";
						break;
		default:
						$tabellen = array ('kasse_drucker', 'kasse_kassen', 'kasse_preise', 'kasse_stat', 'kasse_usr', 'kasse_verkabrech', 'kasse_verkaeufer', 'kasse_verkauf', 'kasse_wsdr');
						foreach($tabellen as $tabelle) {
							$content.=tabelleninhalt($tabelle, $post) . "\n\n";
							echo "Tabelle $tabelle wurde exportiert<br>";
						}
		}

	// $content  = mb_convert_encoding($content,'UTF-8');
	$fHandle  = fopen($filename,'wb');
	fwrite($fHandle, pack("CCC",0xef,0xbb,0xbf));
	if(fwrite($fHandle, $content)== FALSE) {
		echo "<br>Fehler beim schreiben von $filename<br><br";
	} else {
		echo "<br>$filename wurde erfolgreich gespeichert<br><br>";
	}
	fclose($fHandle);
	
	chmod($filename, 0766);
}

function sqlUpload_check() {

	if(isset($_FILES['datei']) && $_FILES['datei']['size'] != 0 && !$_FILES['datei']['error']) {

		$endung = explode('.', $_FILES['datei']['name']);
		$endung = strtolower($endung[sizeof($endung)-1]);

		if($endung != 'sql') {
			$fehler[] = 'ungültige Dateiendung ('.$endung.')';
		}
		
		if($_FILES['datei']['type'] != 'application/sql') {
			$fehler[] = 'ungültiger Dateityp ('.$_FILES['datei']['type'].')';
		}

		if($_FILES['datei']['size'] > 10000000) {
			$fehler[] = 'Datei ist zu groß ('.number_format($_FILES['datei']['size']/'1024', 2,'', '.' ).'kB statt erlaubte '.'10000000'/'1024'.'kB )';
		}
		$neuerName=$_SERVER['DOCUMENT_ROOT'] . DIRECTORY_SEPARATOR . "raapp" . DIRECTORY_SEPARATOR .  "db_export" . DIRECTORY_SEPARATOR . "UPL_" . $_FILES['datei']['name'];

		if(empty($fehler)) {
			if(move_uploaded_file($_FILES['datei']['tmp_name'], $neuerName)) {
				chmod($neuerName, 0766);
				$text = $neuerName;
			}
			$status=TRUE;
		} else {
			$status=FALSE;
			$text = '<b>Folgende Fehler sind aufgetreten:</b><br/>';
			foreach($fehler as $value) {
				$text .= $value.'<br/>';
			}
		}
	}
	return array($status, $text);
}

function sqlImport($post, $filename) {
	include("../config.php");
	global $link;

	if(!file_exists($filename))
		return false;
	
	echo "Datei $filename wird eingelesen<br><br>";
	// Temporary variable, used to store current query
	$templine = '';
	
	if($post['export'] == 'Struktur') {
		echo "hier kommen noch die creates rein<br>";
	}
	
	// Datei einlesen
	$lines = file($filename, FILE_SKIP_EMPTY_LINES);
	$i=0;

	foreach ($lines as $line)
	{	
		// Prüfen 1. Zeile ob es sich um eine raAPP Kasse Datei handelt
		if (substr($line, 0, 17) == '﻿-- raAPP Kasse' && $i==0) {
			echo "raAPP Kasse Datei erkannt<br><br>";
			$i++;
		} else {
			if ( $i==0)	return false;  // keine raAPP Kasse Datei
		}

		// Kommentare überspringen
		if (substr($line, 0, 2) == '--' || $line == '')
			continue;
	
		// Zeile zufügen
		$templine .= $line;
		// semicolon am Ende bedeute Query Statement ist fertig ingelesen
		if (substr(trim($line), -1, 1) == ';')
		{
			// Query ausführen
			// mysqli_query($templine) or print('Error performing query \'<strong>' . $templine . '\': ' . mysql_error() . '<br /><br />');
			echo "Zeile $templine<br>";
			// löschen der variable
			$templine = '';
		}
	}
	unlink($filename);
	echo "<br>Tabellen erfolgreich importiert";
}

function copyDir($sSourcePath, $sTargetPath, $zielrechte) {
	$fehler=true;
	if (is_dir($sSourcePath) && !is_dir($sTargetPath)) {
		if(!mkdir($sTargetPath)) { $fehler=false; }
		if (betriebssystem()!==2) {
			chmod($sTargetPath, $zielrechte);	// chmod funktioniert bei Windows nicht
		}
	}
		foreach ($oIterator = new \RecursiveIteratorIterator(
				new \RecursiveDirectoryIterator($sSourcePath, \RecursiveDirectoryIterator::SKIP_DOTS),
				\RecursiveIteratorIterator::SELF_FIRST) as $oItem)
		{
			if ($oItem->isDir()) {
				$pfad=$sTargetPath.DIRECTORY_SEPARATOR.$oIterator->getSubPathName();
				if(!is_dir($pfad)) {
					if(!mkdir($pfad)) { $fehler=false; }
					if (betriebssystem()!==2) {
						chmod($pfad, $zielrechte);	// chmod funktioniert bei Windows nicht
						}
				}
			} else {
				$pfad=$sTargetPath.DIRECTORY_SEPARATOR.$oIterator->getSubPathName();
				if(!copy($oItem, $pfad)) { $fehler=false; }
				if (betriebssystem()!==2) {
					chmod($pfad, $zielrechte);	// chmod funktioniert bei Windows nicht
				}
			}
		}
		return $fehler;
}

function updaten($raapp_mode, $get) {

	$raapp_pfad=realpath($_SERVER['DOCUMENT_ROOT'] . '/raapp');
	
	$backupverzeichnis=$raapp_pfad . DIRECTORY_SEPARATOR . "backup";
	if (file_exists($backupverzeichnis)===FALSE) {
		// Dateiverzeichnis erzeugen
		mkdir($backupverzeichnis);
		if (betriebssystem()!==2) {
			chmod($backupverzeichnis, 0777);	// chmod funktioniert bei Windows nicht
		}
	}
	
	$updverzeichnis=$raapp_pfad. DIRECTORY_SEPARATOR . "update";
	if (file_exists($updverzeichnis)===FALSE) {
		// Dateiverzeichnis erzeugen
		mkdir($updverzeichnis);
		if (betriebssystem()!==2) {
			chmod($updverzeichnis, 0777);	// chmod funktioniert bei Windows nicht
		}
	}
	
	// Backup der bisherigen Version durchführen
	echo "<div class='aktion'>Sicherung der aktuellen Version</div>";
	
	// Datenbank Struktur und Daten sichern
	$post['export'] = 'Struktur';
	sqlExport($post);
	
	// Scripte sichern
	$script_pfad=$raapp_pfad . DIRECTORY_SEPARATOR . "kasse";
	$script_backup=$backupverzeichnis . DIRECTORY_SEPARATOR . "backup_raAPP_Kasse_" . date("Y-m-d_G-i-s");
	
	echo "Backup der Dateien von $script_pfad nach $script_backup<br>";
	echo "<div id='warten1' class='loader'></div>";
	ob_flush();
	flush();
	
	if(copyDir($script_pfad, $script_backup, 0777)) {
		echo "<p class='aktionOK'>Backup von $script_pfad nach $script_backup erfolgreich erstellt</p>";
	} else {
		echo "<p class='aktionError'>Fehler bei Backup</p>";
	}

	echo "<script>document.getElementById ('warten1').style.display = 'none';</script>";

	ob_flush();
	flush();
	
	// Update vom Server holen
	echo "<p class='aktion'>Die Dateien werden von raAPP.de geholt</p>";
	ob_flush();
	flush();
	if($raapp_mode==1) { // Entwicklungsmodus
		$quelle="http://localhost/raapp/paket/" . $get['p'];
		$o="http://localhost/raapp/raappupd.php?sw=2&p=" . $get['p'];
	} else { // Normalmodus
		$quelle="https://www.raapp.de/paket/" . $get['p'];
		$o="https://www.raapp.de/raappupd.php?sw=2&p=" . $get['p'];
	}
	
	// Paketverzeichnis anlegen
	$paketverzeichnis=$updverzeichnis . DIRECTORY_SEPARATOR . $get['p'];
	if (file_exists($paketverzeichnis)===FALSE) {
		// Dateiverzeichnis erzeugen
		mkdir($paketverzeichnis);
		if (betriebssystem()!==2) {
			chmod($paketverzeichnis, 0777);		// chmod funktioniert bei Windows nicht
		}
	}
	
	// Datei- und Verzeichnisnamen zum Paket vom Server holen
	$fp = fopen($o,'r');
	$dateien=json_decode(fgets($fp), true);
	
	// Zielverzeichnisse im Pakteverzeichnis anlegen
	foreach ($dateien['verz'] as $verz) {
		if (!file_exists($paketverzeichnis . DIRECTORY_SEPARATOR . $verz)) {
			if(!mkdir($paketverzeichnis . DIRECTORY_SEPARATOR . $verz)) {
				echo "<p>Fehler beim erstellen von Verzeichnis $verz</p>";
			} else {
				if (betriebssystem()!==2) {
					chmod($paketverzeichnis . DIRECTORY_SEPARATOR . $verz, 0777);		// chmod funktioniert bei Windows nicht
				}
				echo "Verzeichnis " . $paketverzeichnis . DIRECTORY_SEPARATOR . "$verz - erstellt<br>";
			}
		}
	}
	
	// Dateien vom Server in lokales Paketverzeichnis unter raapp/update kopieren
	echo "<div id='warten2' class='loader'></div>";
	ob_flush();
	flush();
	$zaehler=1;	
	
	foreach ($dateien['datei'] as $datei) {
		$qpfad=$quelle . "/" . $datei;
		$zpfad=$paketverzeichnis . DIRECTORY_SEPARATOR . $datei;
		$zpfad=substr($zpfad, 0, strlen($zpfad)-1);  // angehängten Bindestrich entfernen
		
		if(!@copy($qpfad, $zpfad))
		{
			$errors= error_get_last();
			echo "Fehler beim kopieren der Datei $qpfad von raAPP.de: ".$errors['type'] . "<br />\n".$errors['message'];
			exit();
		} else {
			if (betriebssystem()!==2) {
				chmod($zpfad,0777);		// chmod funktioniert bei Windows nicht
			}
			// echo "Datei erfolgreich von $qpfad nach $zpfad kopiert<br>";
			$zaehler++;
		}
	}
	
	echo "<script>document.getElementById ('warten2').style.display = 'none';</script>
	<p class='aktionOK'>$zaehler Dateien erfolgreich von raAPP.de kopiert</p>";
	
	// Neue Dateien an richtige Stelle kopieren
	echo "<div class='aktion'>Kopiere Update in das Produktivverzeichnis</div>";
	echo "<div id='warten3' class='loader'></div>";
	$zaehler=1;
	
	ob_flush();
	flush();
	
	// Update-Dateien aus Verzeichnis Update in den script Pfad kopieren
	$quelle=$paketverzeichnis;
	$ziel=$script_pfad;
	
	if(copyDir($quelle, $ziel, 0777)) {
		echo "<p class='aktionOK'>Update Dateien erfolgreich von $quelle nach $ziel kopiert</p>";
	} else {
		echo "<p class='aktionError'>Fehler beim kopieren der Update Dateien von $quelle nach $ziel</p>";
	}
	
	echo "<script>document.getElementById ('warten3').style.display = 'none';</script>";

	ob_flush();
	flush();
	
	// Nacharbeiten Update durchführen
	echo "<div class='aktion'>Nacharbeiten durchführen</div>";
	
	// Seite neu laden, damit der Code vom neuen Script ausgeführt wird
	echo "<script>window.location.assign('verwaltung.php?sw=11')</script>";
}

function update_NachNeuLaden() {
	echo "<div class='aktion'>Nacharbeiten durchführen nach Neu laden</div>";
	
	if(updaten_fertigstellen()) {
		echo "<br><br><p class='aktionOK'>Update erfolgreich</p>";
	} else {
		echo "<p class='aktionError'>Update konnte nicht vollst&auml;ndig installiert werden</p>";
	}
	echo "<br><br><br></div>";
}

function updaten_fertigstellen () {
	global $link;
	$fehler=True;
	
	//config.php prüfen und ergänzen
	echo "<p class='aktion'>" . TextExistiertErsetzen("../config.php", "../config.php", "raapp_mode", "?>", "\t\$raapp_mode=0;\n?>") . "</p>";

	// prüfen ob Verzeichnis db_export existiert
	$raapp_pfad=realpath($_SERVER['DOCUMENT_ROOT'] . '/raapp');
	
	$exportverzeichnis=$raapp_pfad . DIRECTORY_SEPARATOR . "db_export";
	if (file_exists($exportverzeichnis)===FALSE) {
		// Dateiverzeichnis erzeugen
		mkdir($exportverzeichnis);
		if (betriebssystem()!==2) {
			chmod($exportverzeichnis, 0777);	// chmod funktioniert bei Windows nicht
		}
	}
	
	// Prüfen Tabelle kasse_verkauf ob Spalte kasssiert existiert
	if(TabelleSpalteExistiert( 'kasse_verkauf', 'kassiert')) {
		echo "<p class='aktion'>Spalte kassiert in Tabelle kasse_verkauf bereits vorhanden</p>";
	} else {
		echo "<div class='aktion'>Tabellenspalte kassiert in Tabelle kasse_verkauf wird angelegt</div>";
		$abfrage="ALTER TABLE `kasse_verkauf` ADD `kassiert` tinyint(4) NOT NULL AFTER `tisch`";
		if(mysqli_query($link, $abfrage)) {
			echo "<p class='aktionOK'>Tabellenspalte kassiert in Tabelle kasse_verkauf wurde erfolgreich angelegt</p>";
		} else {
			echo "<p class='aktionError'>Fehler beim anlegen der Spalte kassiert in Tabell kasse_verkauf</p>";
			$fehler=FALSE;
		}
	}
	
	return($fehler);
}


// Hauptsteuerung Script

if(!isset($_GET['sw'])) {
	$_GET['sw']=0;
}

switch ($_GET['sw']) {
	case 1:		anzeigenDB();
				break;
	case 2:		sqlExport($_POST);
				break;
	case 3:		$r=sqlUpload_check();
				if($r[0]==TRUE) {
					sqlImport($_POST, $r[1]); // Check ok Dateiname wird übergeben
				} else {
					echo "$r[1]";		// Check mit Fehler, Fehlertext ausgeben
				}
				break;
	case 5:		set_time_limit(240); // 4 Minuten für langsame Verbindungen
				updaten($raapp_mode, $_GET);
				break;
	case 11:
				update_NachNeuLaden($_GET);
				break;
	default:	anzeigenUpd();
				break;
}

mysqli_close($link);
echo "</div>";
seitenfuss();
htmlende();
?>