/*
Copyright 2017	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/

var neuerverkauf;
var db;
var dbName = "raAppKasse";
var dbVersion = "1.1";
var dbAnzeigename = "raApp Kasse";
var dbMaxSize = 1024; /* Angabe in kb */
var dbTyp = 0; /* 0= keine Datenbankunterstützung, 1=SQLite, 2= IndexedDB */
var verkaeufer_id;
var xmltransfer;
var orient;
var accountstatus;
var buttonseite=0;
var tischnummer=0;
var tischarray=[];
var tischabrecharray=[];
var tischsumme=0.0;
var rueckgeldarray=[];
var rueckgeldsumme=0.0;


/* Datumstempel mit YYYY-MM-TT initialisieren */
var aktuelleZeit = new Date();
var monat2stellig = new Array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
var tag2stellig = new Array("00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19",
							"20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31");
var datumstempel = aktuelleZeit.getFullYear() + "-" + monat2stellig[aktuelleZeit.getMonth()] + "-" + tag2stellig[aktuelleZeit.getDate()];

/* Datenbank öffnen/erzeugen */
if(typeof window.openDatabase != 'undefined') {
	dbTyp=1;
	if (!window.openDatabase) {
	    	alert('Achtung !!\nraAPP Kasse ist nicht nutzbar.\n\nDie lokale Datenbank konnte nicht angelegt werden !');
		} else {
			db = openDatabase(dbName, dbVersion, dbAnzeigename, dbMaxSize);
			sqlite_dbtable_erzeugen();
		}
} else if(typeof window.IDBVersionChangeEvent != 'undefined') {
	dbTyp=2;
	var request = indexedDB.open(dbName, 1);
	/* Event indexeddb verarbeiten */
	request.onupgradeneeded = function(){
		  console.log('Datenbank angelegt');
		  db = this.result;
		  if(!db.objectStoreNames.contains('verkauf')){
		    store = db.createObjectStore('verkauf', {
		      keyPath: 'id',
		      autoIncrement: true
		    });
		  }
		};
		request.onsuccess = function(){
			  console.log('Datenbank geöffnet');
			  db = this.result;
			};
} else {
	dbTyp=0;
	alert('Achtung !!\nraAPP Kasse ist nicht in vollem Umfang nutzbar.\n\nIhr Browser unterstützt keine lokale Datenbank !\nDie Verkäufe können nicht gespeichert und versendet werden.');
}

/* Verkaufsarray initialisieren */
if (neuerverkauf != 0) {
	var a_verkauf = new Array();
	var a_position = 0;
	var a_summe = 0;
}

/* ohne URL Zeile anzeigen */
window.addEventListener('load', function(){
	  setTimeout(scrollTo, 0, 0, 1);
	}, false);

/* Alle divs ausblenden */
function div_zu() {
	document.getElementById ('startseite').style.display = 'none';
	document.getElementById ('head_back').style.display = 'none';
	document.getElementById ('head_tisch').style.display = 'none';
	document.getElementById ('head_verkaeufer').style.display = 'none';
	document.getElementById ('head_del').style.display = 'none';
	document.getElementById ('head_send').style.display = 'none';
	document.getElementById ('head_laden').style.display = 'none';
	document.getElementById ('kasse').style.display = 'none';
	document.getElementById ('tisch').style.display = 'none';
	document.getElementById ('tischabrechnung').style.display = 'none';
	document.getElementById('rueckgeldanzeige').style.display = "none";
	document.getElementById ('klist').style.display = 'none';
	document.getElementById ('k_param').style.display = 'none';
	document.getElementById ('k_laden').style.display = 'none';
	document.getElementById ('k_preisl').style.display = 'none';
	document.getElementById ('k_verkaeufer').style.display = 'none';
	document.getElementById ('k_verkaufsliste').style.display = 'none';
	document.getElementById ('k_verkaufsend').style.display = 'none';
	document.getElementById ('lizenz').style.display = 'none';
	document.getElementById ('setup').style.display = 'none';
}

/* Kasse Starten */
function kasse_start() {
	div_zu();

	document.getElementById ('header').style.display = 'block';
	if (localStorage.getItem("Tischabrechnung") == 1) {
		document.getElementById ('head_tisch').style.display = 'inline';
		document.getElementById("head_tischnummer").innerHTML= tischnummer;
	}
	document.getElementById ('head_verkaeufer').style.display = 'inline';
	document.getElementById ('kasse').style.display = 'block';
	
	if ( verkaeufer_id == undefined) {
		verkaeufer_id=0;
		var name = localStorage.getItem("Vorname" + verkaeufer_id) + " " + localStorage.getItem("Nachname" + verkaeufer_id);
		document.getElementById("head_verkaeufertext").innerHTML = name;
	}
	
	
	var f = "";
	var kl = 'class="kasse_button';
	if(buttonseite==0) {
		for ( var i=0; i<18; i++) {
			f += '<div id="kb' + i + '"' + kl + '" onclick="klick_button(' + i + ')"></div>';
		}
		document.getElementById("kasse_bblock").innerHTML= f;
		button_beschriften();
		buttonseite=1;
	} else {
		for ( var i=18; i<36; i++) {
			f += '<div id="kb' + i + '"' + kl + '" onclick="klick_button(' + i + ')"></div>';
			}
		document.getElementById("kasse_bblock").innerHTML= f;
		button_beschriften();
		buttonseite=0;
	}
}

/* Tischabrechbung starten */
function tisch_start() {
	div_zu();
	document.getElementById ('header').style.display = 'block';
	document.getElementById ('head_tisch').style.display = 'inline';
	document.getElementById("head_tischnummer").innerHTML= tischnummer;
	document.getElementById ('head_verkaeufer').style.display = 'inline';
	
	document.getElementById ('tisch').style.display = 'block';
	
	var f = "";
	var kl = 'class="kasse_button';
	for ( var i=1; i<10; i++) {
			f += '<div id="tb' + i + '"' + kl + '" onclick="klick_tbutton(' + i + ')"><div id="tisch_buttontext" class="kasse_buttontext">' + i + '</div></div>';
		}
	i=0;
	X="X";
	f += '<div id="tb' + i + '"' + kl + '" onclick="klick_tbutton(' + i + ')"><div id="tisch_buttontext" class="kasse_buttontext">' + i + '</div></div>';
	f += '<div id="tbl"' + kl + '" onclick="klick_tbutton(X)"><div id="tisch_buttontext" class="kasse_buttontext farbe_rot">löschen</div></div>';
	document.getElementById("tisch_bblock").innerHTML= f;
	buttonseite=0;
}


/* Setup Starten */
function setup_start() {
	div_zu();
	buttonseite=0;
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="kasse_start()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('setup').style.display = 'block';
}

/* Param Starten */
function param_start() {
	div_zu();
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="chk_F_KasseParam()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('k_param').style.display = 'block';
	F_KasseParam();
}

/* laden Starten */
function laden_param_start() {
	div_zu();
	document.getElementById ('head_laden').style.display = 'inline';
	document.getElementById ('head_laden').innerHTML='<a id="head_back" class="header" href="#" onclick="laden_param()"><img src="./images/raapp_laden.png"></a>';
	document.getElementById ('k_laden').style.display = 'block';
}

/* Preisliste Starten */
function preisl_start() {
	div_zu();
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="chk_F_Preisl()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('k_preisl').style.display = 'block';
	var f = "";
	for ( var i=1; i<36; i++) {
		f += '<input name="ArtikelName" type="text" size="15" value=""> ';
		f += '<input name="ArtikelPreis" type="text" size="5" value=""> ';
		f += '<input name="ButtonFarbe" type="button" id="farbbutton" value="Farbe" onclick="farbauswahl(';
		f += i;
		f += ')" readonly><br>';
	}
	document.getElementById("f_preisliste_felder").innerHTML= f;
	F_Preisl();
}

/* Verkäufer Starten */
function verkaeufer_start() {
	div_zu();
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="chkFormularVerkaeufer()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('k_verkaeufer').style.display = 'block';
	var f = "";
	for ( var i=1; i<12; i++) {
		f += '<input name="Vorname" type="text" size="15" value=""> ';
		f += '<input name="Nachname" type="text" size="15" value=""><br>';
	}
	document.getElementById("f_verkaeufer_felder").innerHTML= f;
	FormularVerkaeufer();
}

/* Verkaufsliste Starten */
function verk_liste_start() {
	div_zu();
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="setup_start()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('head_del').style.display = 'inline';
	document.getElementById ('head_del').innerHTML='<a id="head_del" class="header" href="#" onclick="verk_loeschen()"><img src="./images/raapp_del.png"></a>';
	document.getElementById ('k_verkaufsliste').style.display = 'block';
	/* zuerst mal die HTML-Knoten vom vorherigen anzeigen löschen */
    var table = document.getElementById('verkauf');
    for(var i = table.rows.length - 1; i > 0; i--) {
    	table.deleteRow(i);
    }
	dbTabelleAnzeigen();
}

function verk_loeschen() {
	var r=confirm("Wollen Sie den Verkauf wirklich löschen ?");
	if (r==true)
	  {
		dbTabelleLoeschen();
		verk_liste_start();
	  }
}

/* Verkaufsenden Starten */
function verk_send_start() {
	div_zu();
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="setup_start()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('head_send').style.display = 'inline';
	document.getElementById ('head_send').innerHTML='<a id="head_del" class="header" href="#" onclick="Senden_XML()"><img src="./images/raapp_send.png"></a>';
	document.getElementById ('k_verkaufsend').style.display = 'block';
	erzeuge_XML(1);
}

/* Lizenz anzeigen */
function lizenz_start() {
	div_zu();
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="chk_F_KasseParam()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('lizenz').style.display = 'block';
	var f = '<h3>Lizenzbestimmungen</h3>';
		f += 'This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by ';
		f += 'the Free Software Foundation, either version 3 of the License, or (at your option) any later version.<br><br>';
		f += 'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of ';
		f += 'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.<br><br>';
		f += 'You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.<br><br>';
		f += 'Dieses Programm ist Freie Software: Sie können es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation, ';
		f += 'Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren veröffentlichten Version, weiterverbreiten und/oder modifizieren.<br><br>';
		f += 'Dieses Programm wird in der Hoffnung, dass es nützlich sein wird, aber OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite ';
		f += 'Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK. Siehe die GNU General Public License für weitere Details.<br><br>';
		f += 'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben.<br>Wenn nicht, siehe <a href="http://www.gnu.org/licenses">http://www.gnu.org/licenses/</a>.';
	document.getElementById("lizenz").innerHTML= f;
}

/* Verkäufer Button beschriften */
function kasse_verkaeufer_button() {
	if ( verkaeufer_id != undefined) {
		verkaeufer_id++;
		if (localStorage.getItem("Vorname" + verkaeufer_id) == null || localStorage.getItem("Vorname" + verkaeufer_id).length < 1) {
			verkaeufer_id=0;
		}
	} else {
		verkaeufer_id = 0;
	}
	var name = localStorage.getItem("Vorname" + verkaeufer_id) + " " + localStorage.getItem("Nachname" + verkaeufer_id);
	document.getElementById("head_verkaeufertext").innerHTML = name;
}

/* Kassen-Buttons beschriften */
function button_beschriften() {
	if(buttonseite==0) {
		for ( var i=0; i<18; i++) {
			kb="kb" + i;
			if (localStorage.getItem("Name" + i).length >1 ) {
				document.getElementById(kb).innerHTML = "<div id='kasse_buttontext' class='kasse_buttontext'>" + localStorage.getItem("Name" + i) + "<br>" + localStorage.getItem("Preis" + i) + "</div>";
				document.getElementById(kb).style.backgroundColor = localStorage.getItem("Farbe" + i);
			}
		}
	} else {
		for ( var i=18; i<36; i++) {
			kb="kb" + i;
			if (localStorage.getItem("Name" + i).length >1 ) {
				document.getElementById(kb).innerHTML = "<div id='kasse_buttontext' class='kasse_buttontext'>" + localStorage.getItem("Name" + i) + "<br>" + localStorage.getItem("Preis" + i) + "</div>";
				document.getElementById(kb).style.backgroundColor = localStorage.getItem("Farbe" + i);
			}
		}
	}
}

function klick_button(button_nr) {
	if(localStorage.getItem("Name" + button_nr).length >1) {
		aktuelleZeit = new Date();
		zeitstempel = aktuelleZeit.getHours() + ":" + aktuelleZeit.getMinutes() + ":" + aktuelleZeit.getSeconds();
		neuerverkauf = 1;
		a_position++;
		a_verkauf[a_position] = new Object();
		a_verkauf[a_position]["Datum"] = datumstempel;
		a_verkauf[a_position]["Zeit"] = zeitstempel;
		a_verkauf[a_position]["Verkaeufer"] = localStorage.getItem("Vorname" + verkaeufer_id) + " " + localStorage.getItem("Nachname" + verkaeufer_id);
		a_verkauf[a_position]["Name"] = localStorage.getItem("Name" + button_nr);
		a_verkauf[a_position]["Preis"] = Number(localStorage.getItem("Preis" + button_nr));
		a_verkauf[a_position]["Anzahl"] = 1;
		a_verkauf[a_position]["Tisch"] = tischnummer;
		a_summe += Number(localStorage.getItem("Preis" + button_nr));
		var art ="";
		if(a_verkauf[a_position]["Preis"] >0) {
			art = "<div class='kasse_buttontext'>";
		} else {
			art = "<div class='kasse_buttontext farbe_rot'>";
		}
		art += a_verkauf[a_position]["Name"] + "<br>" + number_format(a_verkauf[a_position]["Preis"], 2, ".") + "</div>";
		var ksum = "";
		if(a_summe >0) {
			ksum = "<div class='kasse_buttontext'>";
		}else {
			ksum = "<div class='kasse_buttontext farbe_rot'>";
		}
		ksum += number_format(a_summe, 2, ".") + "</div>";
		document.getElementById("kasse_liste_artikel").innerHTML = art;
		document.getElementById("kasse_liste_summe").innerHTML = ksum;
	}
}

function klick_tbutton(button) {
	if(button=="X") {
		tischarray.pop();
	} else {
		tischarray.push(button);
	}
	if(tischarray.length==0) {
		tischnummer=0;
	} else {
		tisch=tischarray.join("");
		tischnummer=parseInt(tisch);
	}
	document.getElementById("head_tischnummer").innerHTML = tischnummer;
}

function kasse_klick_liste() {
	div_zu();
	buttonseite=0;
	document.getElementById ('head_back').style.display = 'inline';
	document.getElementById ('head_back').innerHTML='<a id="head_back" class="header" href="#" onclick="kasse_start()"><img src="./images/raapp_back.png"></a>';
	document.getElementById ('klist').style.display = 'block';
	var inhalt = "<span class=klist><table>";
	for ( var i = 1; i < a_verkauf.length; i++) {
		inhalt += "<tr><th>";
		if(a_verkauf[i]["Preis"]>0) {
			inhalt += "<span class='farbe_sw'>" + a_verkauf[i]["Name"] + "</span></th><td><span class='farbe_sw'>" + number_format(a_verkauf[i]["Preis"], 2, ".") + "</span></td><td><a href='#' onclick='storno_from_list(" + i + ")'><img src='./images/raapp_del.png'></a></td></tr>";
		} else {
			inhalt += "<span class='farbe_rot'>" + a_verkauf[i]["Name"] + "</span></th><td><span class='farbe_rot'>" + number_format(a_verkauf[i]["Preis"], 2, ".") + "</span></td><td><a href='#' onclick='storno_from_list(" + i + ")'><img src='./images/raapp_del.png'></a></td></tr>";
		}						
	}
	inhalt += "</table></span>";
	
	document.getElementById("klist").innerHTML = inhalt;
}
 
function klick_storno() {
	/* kompletten Verkauf stornieren */
		var anz = a_verkauf.length;
		for ( var i = 1; i < anz; i++) {
			storno_daten(i);
			}
		klick_buchen();
}

function storno_from_list(posi) {
	storno_daten(posi);
	a_summe += Number(a_verkauf[a_position]["Preis"]);
	
	var art ="";
	if(a_verkauf[a_position]["Preis"] >0) {
		art = "<div class='kasse_buttontext'>";
	} else {
		art = "<div class='kasse_buttontext farbe_rot'>";
	}
	art += a_verkauf[a_position]["Name"] + "<br>" + number_format(a_verkauf[a_position]["Preis"], 2, ".") + "</div>";
	var ksum = "";
	if(a_summe >0) {
		ksum = "<div class='kasse_buttontext'>";
	}else {
		ksum = "<div class='kasse_buttontext farbe_rot'>";
	}
	ksum += number_format(a_summe, 2, ".") + "</div>";
	document.getElementById("kasse_liste_artikel").innerHTML = art;
	document.getElementById("kasse_liste_summe").innerHTML = ksum;
	
	kasse_klick_liste();
}

function storno_daten (posi){
	var position = posi;
	a_position = a_verkauf.length;
	a_verkauf[a_position] = new Object();
	a_verkauf[a_position]["Datum"] = datumstempel;
	a_verkauf[a_position]["Zeit"] = zeitstempel;
	a_verkauf[a_position]["Verkaeufer"] = a_verkauf[position]["Verkaeufer"];
	a_verkauf[a_position]["Name"] = a_verkauf[position]["Name"];
	a_verkauf[a_position]["Preis"] = -Number(a_verkauf[position]["Preis"]);
	a_verkauf[a_position]["Anzahl"] = -1;
	a_verkauf[a_position]["Tisch"] = tischnummer;
}

function klick_buchen() {
	var kopie_verkauf = [].concat(a_verkauf);
	if (dbTyp==1) { 
		db.transaction(
			function(transaction) {
				for ( var i = 1; i < kopie_verkauf.length; i++) {
					transaction.executeSql(
						'INSERT INTO verkauf (datum, zeit, verkaeufer, artikel, preis, anzahl, tisch) VALUES (?, ?, ?, ?, ?, ?, ?);',
						[kopie_verkauf[i]["Datum"], kopie_verkauf[i]["Zeit"], kopie_verkauf[i]["Verkaeufer"], kopie_verkauf[i]["Name"], kopie_verkauf[i]["Preis"], kopie_verkauf[i]["Anzahl"], kopie_verkauf[i]["Tisch"]],
						function() {
						},
						errorHandler
						);
					}
			}
	);
	}
	if (dbTyp==2) {
		for ( var i = 1; i < kopie_verkauf.length; i++) {
			var item = { datum: kopie_verkauf[i]["Datum"], zeit: kopie_verkauf[i]["Zeit"], verkaeufer: kopie_verkauf[i]["Verkaeufer"], artikel: kopie_verkauf[i]["Name"], preis: kopie_verkauf[i]["Preis"], anzahl: kopie_verkauf[i]["Anzahl"], tisch: kopie_verkauf[i]["Tisch"] };
			var trans = db.transaction(['verkauf'], 'readwrite');
			var store = trans.objectStore('verkauf');
			var request = store.put(item);
			request.onsuccess = function(evt){
				  console.log('Eintrag ' + evt.target.result + ' gespeichert'); 
				};
		}
	}
	/* accountstatus ist noch Unsinn, warum hatte ich den da reingeschrieben */
//	if(accountstatus=1) {
		drucken(kopie_verkauf);
//	}
	
	/* Anzeigen Summe */
	document.getElementById('ksumme').style.display = "block";
	document.getElementById("ksumme").innerHTML = '<div id="ksumme_b" class="ksumme_b" onclick="klick_fertig()"><br><br>Summe<br><br>' + number_format(a_summe, 2, ".") + '</div>';
}

/*Abrechnung Tisch */
function klick_tischabrech() {
	div_zu();
	tischsumme=0;
	verkaeufer=localStorage.getItem("Vorname" + verkaeufer_id) + " " + localStorage.getItem("Nachname" + verkaeufer_id);

	document.getElementById ('tischabrechnung').style.display = 'block';
	
	/* nicht abgerechnete Artikel für Tisch vom Server holen */
	xmltransfer = '<?xml version="1.0" encoding="UTF-8"?>\n' +
	'<transfer>\n<account>' + localStorage.getItem("Account") + 
	'</account>\n<kasse>' + localStorage.getItem("KassenId") + 
	'</kasse>\n<mail>' + localStorage.getItem("MailVerkauf") +
	'</mail>\n<verkaeufer>' + verkaeufer + '</verkaeufer>\n<tisch>' + tischnummer + '</tisch>\n</transfer>';
	xmlhttp=new XMLHttpRequest();
	xmlhttp.open("POST","../kasse_tisch.php?sw=1",false);
	xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlhttp.send("xml=" + xmltransfer);
	if(xmlhttp.responseText.length>4) {
		var myJSONObject=JSON.parse(xmlhttp.responseText);
		
		/* Artikel zum Tisch anzeigen */
		
		var inhalt = "<span id=tischlist><table>";
		for ( var i = 0; i < myJSONObject.length; i++) {
			inhalt += "<tr><th>";
			inhalt += "<span class='farbe_sw'>" + myJSONObject[i].artikel + "</span></th><td><span class='farbe_sw'>" + number_format(myJSONObject[i].preis, 2, ".") + "</span></td><td><div id='tischabrechbutton" + myJSONObject[i].satz + "'><a href='#' onclick='klick_tischabrech_artikel(" + myJSONObject[i].preis + ", " + myJSONObject[i].satz + ", 1" +")'><img src='./images/raapp_button.png'></a></div></td></tr>";
		}
		inhalt += "</table></span>";
		inhalt += "<div id='tischsumme' class='ksumme_b' onclick='klick_tischabrechsend()'>" + number_format(tischsumme, 2, ".") + "</div>";
	} else {
		inhalt="<span class='farbe_rot'>kein Artikel für Tisch " + tischnummer + " abzurechnen</span>";
	}
	
	document.getElementById("tischabrechnung").innerHTML = inhalt;
}

/* bildet Tischsumme */
	
function klick_tischabrech_artikel(preis, satznr, auswahl) {
	if(auswahl==1) {
		tischsumme +=Number(preis);
		document.getElementById("tischsumme").innerHTML = number_format(tischsumme, 2, ",");
		var a = "<a href='#' onclick='klick_tischabrech_artikel(" + preis + ", " + satznr + ", 0" +")'><img src='./images/raapp_ok.png'></a>";
		document.getElementById("tischabrechbutton"+satznr).innerHTML = a;
		tischabrecharray.push(satznr);
		// alert(tischabrecharray);
	} else {
		tischsumme -=Number(preis);
		document.getElementById("tischsumme").innerHTML = number_format(tischsumme, 2, ",");
		var a = "<a href='#' onclick='klick_tischabrech_artikel(" + preis + ", " + satznr + ", 1" +")'><img src='./images/raapp_button.png'></a>";
		document.getElementById("tischabrechbutton"+satznr).innerHTML = a;
		var index = tischabrecharray.indexOf(satznr);
		tischabrecharray[index]=0;
		// alert(tischabrecharray);
	}
}

function klick_tischabrechsend () {
	var a="<saetze>\n";
	for ( var i = 0; i < tischabrecharray.length; i++) {
		if(tischabrecharray[i]>0) {
			a +="<satz>" + tischabrecharray[i] + "</satz>\n";
		}
	}
	a +="</saetze>\n";

	xmltransfer = '<?xml version="1.0" encoding="UTF-8"?>\n' +
	'<transfer>\n<account>' + localStorage.getItem("Account") + 
	'</account>\n<kasse>' + localStorage.getItem("KassenId") + 
	'</kasse>\n<mail>' + localStorage.getItem("MailVerkauf") +
	'</mail>\n<verkaeufer>' + verkaeufer + '</verkaeufer>\n' + a + '</transfer>';
	xmlhttp=new XMLHttpRequest();
	xmlhttp.open("POST","../kasse_tisch.php?sw=2",false);
	xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlhttp.send("xml=" + xmltransfer);
	
	if(xmlhttp.responseText=="False") {
		alert("Fehler beim schreiben in die Datenbank");
	} else {
		if (localStorage.getItem("Rueckgeldfunktion") == 1) {
			rueckgeldfunktion();
		}
	}
}

function rueckgeldfunktion() {
	document.getElementById ('tischabrechnung').style.display = 'none';
	document.getElementById('rueckgeldanzeige').style.display = "block";
	var inhalt="<div id='tisch_bblock2' class='kasse_bblock2'><div class='kasse_liste_artikel h_farbe_gruen'><div id='rtischsumme' class='kasse_buttontext'>Summe<br>" + number_format (tischsumme, '2', ',', '.') + "</div></div>";
	inhalt +="<div class='kasse_liste_artikel h_farbe_hblau'><div id='gegeben' class='kasse_buttontext'>gegeben<br>0,00</div></div>";
	inhalt +="<div class='kasse_liste_artikel h_farbe_hblau'><div id='zurueckgeben' class='kasse_buttontext'>Rausgeld<br>0,00</div></div></div>";
	
	rueckgeldarray = [];
	var f = "<div id='tisch_bblock' class='kasse_bblock'>";
	var kl = 'class="kasse_button"';
	for ( var i=1; i<10; i++) {
			f += '<div id="tb' + i + '"' + kl + '" onclick="klick_rbutton(' + i + ')"><div class="kasse_buttontext">' + i + '</div></div>';
		}
	i=0;
	X="X";
	K=".";
	f += '<div id="tb' + i + '"' + kl + '" onclick="klick_rbutton(' + i + ')"><div class="kasse_buttontext">' + i + '</div></div>';
	f += '<div id="tbp"' + kl + '" onclick="klick_rbutton(K)"><div class="kasse_buttontext">,</div></div>';
	f += '<div id="tbl"' + kl + '" onclick="klick_rbutton(X)"><div class="kasse_buttontext farbe_rot">löschen</div></div>';
	inhalt +="</div>"+f;
	document.getElementById("rueckgeldanzeige").innerHTML = inhalt;
}

function klick_rbutton(button) {
	if(button=="X") {
		rueckgeldarray.pop();
	} else {
		rueckgeldarray.push(button);
	}
	if(rueckgeldarray.length==0) {
		rueckgeldsumme=0.0;
	} else {
		rueck=rueckgeldarray.join("");
		rueckgeldsumme=parseFloat(rueck);
	}
	var zurueck = rueckgeldsumme-tischsumme;
	document.getElementById("gegeben").innerHTML = "gegeben<br>" + number_format(rueckgeldsumme, '2', ',', '.');
	if(zurueck<0) {
		document.getElementById("zurueckgeben").innerHTML = "<span class='farbe_rot'>Rückgeld<br>" + number_format (zurueck, '2', ',', '.') + "</span>";
	} else {
		document.getElementById("zurueckgeben").innerHTML = "<span class='farbe_gruen'>Rückgeld<br>" + number_format (zurueck, '2', ',', '.') + "</span>";
	}
}

/* nach Anzeigen Summe  ksumme box wieder ausblenden und verkauf auf 0 setzen */
function klick_fertig() {
	document.getElementById('ksumme').style.display = "none";
	a_verkauf.length = 0;
	a_position=0;
	a_summe=0;
	document.getElementById("kasse_liste_artikel").innerHTML = "";
	document.getElementById("kasse_liste_summe").innerHTML = "<div id='kasse_buttontext' class='kasse_buttontext'>0.00</div>";
	/* Im Mehrbenutzerbetrieb Verkäufer auswählen */
	if(localStorage.getItem("Mehrbenutzer") == 1) {
		verkaeufer_auswahl();
	}
}

/* nach Anzeigen Summe im Mehrbenutzerbetrieb Verkäufer zur Auswahl anzeigen */
function verkaeufer_auswahl() {
	verkaeufer_id=0;
	document.getElementById('kverkaeufer').style.display = "block";
	var v = "";
	while (localStorage.getItem("Vorname" + verkaeufer_id).length > 1) {
		v += '<div id="kverkaeufer_b" onclick="klick_fertig_verkaeufer(' + verkaeufer_id + ')">'
				+ localStorage.getItem("Vorname" + verkaeufer_id) + " "
				+ localStorage.getItem("Nachname" + verkaeufer_id)
				+ '</div>';
		verkaeufer_id++;
	}	
	document.getElementById("kverkaeufer").innerHTML = v;
}

/* nach Verkäufer Auswahl Verkäufer setzen und weiter */
function klick_fertig_verkaeufer(verk) {
	verkaeufer_id=verk;
	document.getElementById("head_verkaeufertext").innerHTML = localStorage.getItem("Vorname" + verk) + " " + localStorage.getItem("Nachname" + verk);
	document.getElementById('kverkaeufer').style.display = "none";
}

/* Bon drucken wenn Account ID verfügbar */
function drucken(kopie_verkauf) {
	if(localStorage.getItem("Online") == 1 & kopie_verkauf.length > 0) {
		xmltransfer = '<?xml version="1.0" encoding="UTF-8"?>\n' +
					'<transfer>\n<account>' + localStorage.getItem("Account") + 
					'</account>\n<kasse>' + localStorage.getItem("KassenId") + 
					'</kasse>\n<mail>' + localStorage.getItem("MailVerkauf") + '</mail>\n';
		for ( var i = 1; i < kopie_verkauf.length; i++) {
			xmltransfer += "<verkauf>\n<verkaeufer>" + kopie_verkauf[i]['Verkaeufer'] + "</verkaeufer>\n<artikel>" +
				kopie_verkauf[i]['Name'] + "</artikel>\n<preis>" + kopie_verkauf[i]['Preis'] + "</preis>\n<anzahl>" + kopie_verkauf[i]['Anzahl'] + "</anzahl>\n<tisch>" + kopie_verkauf[i]['Tisch'] + "</tisch>\n</verkauf>\n";
		}
		xmltransfer += "</transfer>";
		xmlhttp=new XMLHttpRequest();
		xmlhttp.open("POST","../kasse_druck.php",false);
		xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		xmlhttp.send("xml=" + xmltransfer);
		if(xmlhttp.responseText != 1) {	alert(xmlhttp.responseText); }
	}
}

/* ########  Kassenparam  ########### */
/* Felder fals vorhanden im Formular vorbelegen */
function F_KasseParam() {
	if (localStorage.getItem("KassenId") != null) {
		document.forms.f_kassenparam.KassenId.value = localStorage.getItem("KassenId");
	}
	if (localStorage.getItem("MailVerkauf") != null) {
		document.forms.f_kassenparam.MailVerkauf.value = localStorage.getItem("MailVerkauf");
	}
	if (localStorage.getItem("Online") != null) {
		if (localStorage.getItem("Online") == 1) {
			document.forms.f_kassenparam.Online.checked = true;
		}
	}
	if (localStorage.getItem("Account") != null) {
		document.forms.f_kassenparam.Account.value = localStorage.getItem("Account");
	}
	if (localStorage.getItem("Mehrbenutzer") != null) {
		if (localStorage.getItem("Mehrbenutzer") == 1) {
			document.forms.f_kassenparam.Mehrbenutzer.checked = true;
		}
	}
	if (localStorage.getItem("Tischabrechnung") != null) {
		if (localStorage.getItem("Tischabrechnung") == 1) {
			document.forms.f_kassenparam.Tischabrechnung.checked = true;
		}
	}
	if (localStorage.getItem("Rueckgeldfunktion") != null) {
		if (localStorage.getItem("Rueckgeldfunktion") == 1) {
			document.forms.f_kassenparam.Rueckgeldfunktion.checked = true;
		}
	}
}

/* Formulareingaben Kasseparam nach submit verarbeiten */
function chk_F_KasseParam() {
	localStorage.setItem ( "KassenId", document.forms.f_kassenparam.KassenId.value);
	localStorage.setItem ( "MailVerkauf", document.forms.f_kassenparam.MailVerkauf.value);
	
	if (document.forms.f_kassenparam.Online.checked == true) {
		localStorage.setItem ( "Online", 1);
	} else { localStorage.setItem ( "Online", 0); }
	
	localStorage.setItem ( "Account", document.forms.f_kassenparam.Account.value);
	
	if (document.forms.f_kassenparam.Mehrbenutzer.checked == true) {
		localStorage.setItem ( "Mehrbenutzer", 1);
	} else { localStorage.setItem ( "Mehrbenutzer", 0); }
	
	if (document.forms.f_kassenparam.Tischabrechnung.checked == true) {
		localStorage.setItem ( "Tischabrechnung", 1);
	} else { localStorage.setItem ( "Tischabrechnung", 0); }
	
	if (document.forms.f_kassenparam.Rueckgeldfunktion.checked == true) {
		localStorage.setItem ( "Rueckgeldfunktion", 1);
	} else { localStorage.setItem ( "Rueckgeldfunktion", 0); }
	
	setup_start();
}

/* Artikel, Preise und Drucker vom Server holen */
function laden_param() {
	xmltransfer = '<?xml version="1.0" encoding="UTF-8"?>\n' +
	'<transfer>\n<account>' + localStorage.getItem("Account") + 
	'</account>\n<kasse>' + localStorage.getItem("KassenId") + 
	'</kasse>\n<mail>' + localStorage.getItem("MailVerkauf") + '</mail>\n</transfer>';
	xmlhttp=new XMLHttpRequest();
	xmlhttp.open("POST","../kasse_ladenparam.php",false);
	xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlhttp.send("xml=" + xmltransfer);
	var JSONObject=JSON.parse(xmlhttp.responseText);
	
	/* Verkaeufer speichern */
	var i;
	for(i=0;i<12;i++){
		if( JSONObject.verkaeufer[i].Vorname != null ) { localStorage.setItem ( "Vorname" + i, JSONObject.verkaeufer[i].Vorname); }
		if( JSONObject.verkaeufer[i].Nachname != null ) { localStorage.setItem ( "Nachname" + i, JSONObject.verkaeufer[i].Nachname); }
	}

	/* Buttons speichern */
	for(i=0;i<36;i++){
		if( JSONObject.button[i].Artikel != null ) {
			localStorage.setItem ( "Name" + i, JSONObject.button[i].Artikel);
			localStorage.setItem ( "Preis" + i, JSONObject.button[i].Preis);
			localStorage.setItem ( "Farbe" + i, JSONObject.button[i].Farbe);
		} else {
			localStorage.setItem ( "Name" + i, '');
			localStorage.setItem ( "Preis" + i, '');
			localStorage.setItem ( "Farbe" + i, '');			
		}
	}
	/* alert(xmlhttp.responseText); */
	buttonseite=0;
	kasse_start();
}

/* ########  Preisliste  ########### */
/* Artikel und Preise fals vorhanden im Formular vorbelegen */
function F_Preisl() {
	for(  var i=0;i<36;i++){
		if (localStorage.getItem("Preis" + i) != null && Number(localStorage.getItem("Preis" + i)) != 0) {
			document.forms.f_preisliste.ArtikelName[i].value = localStorage.getItem("Name" + i);
			document.forms.f_preisliste.ArtikelPreis[i].value = localStorage.getItem("Preis" + i);
			document.forms.f_preisliste.ButtonFarbe[i].style.backgroundColor = localStorage.getItem("Farbe" + i);
		}
	}
}

/* Formulareingaben Preisliste nach submit verarbeiten */
function chk_F_Preisl() {
	var i, n;
	for(i=0;i<36;i++){
		localStorage.setItem ( "Name" + i, document.forms.f_preisliste.ArtikelName[i].value);
		
		if (document.forms.f_preisliste.ArtikelPreis[i].value.indexOf(",")>0) {
			n=document.forms.f_preisliste.ArtikelPreis[i].value.replace(",",".");
		} else {
			n = document.forms.f_preisliste.ArtikelPreis[i].value;
		}
		if (Number(n)!=0) {
			n = number_format (n, 2, ".");
			localStorage.setItem ( "Preis" + i, n);
		} else {
			localStorage.setItem ( "Preis" + i, 0);
		}
	}
	setup_start();
}

function farbauswahl(button_nr) {
		switch (localStorage.getItem("Farbe" + button_nr)) {
			case "#80FF80":	f = "#80FFFF";
				break;
			case "#80FFFF":	f = "#FF80FF";
				break;
			case "#FF80FF":	f = "#f5f5f5";
				break;
			case "#f5f5f5":	f = "#80FF80";
				break;
			default:		f = "#f5f5f5";
				break;
		}
	localStorage.setItem ( "Farbe" + button_nr, f);
	document.forms.f_preisliste.ButtonFarbe[button_nr].style.backgroundColor = f;
}

/* ########  Verkäufer  ########### */
/* Verkäufer fals vorhanden im Formular vorbelegen */
function FormularVerkaeufer() {
	for(  var i=0;i<12;i++){
		if (localStorage.getItem("Nachname" + i) != null) {
			document.forms.f_verkaeufer.Vorname[i].value = localStorage.getItem("Vorname" + i);
			document.forms.f_verkaeufer.Nachname[i].value = localStorage.getItem("Nachname" + i);
		}
	}
}

/* Formulareingaben Verkäufer nach submit verarbeiten */
function chkFormularVerkaeufer() {
	var i;
	for(i=0;i<12;i++){
		localStorage.setItem ( "Vorname" + i, document.forms.f_verkaeufer.Vorname[i].value);
		localStorage.setItem ( "Nachname" + i, document.forms.f_verkaeufer.Nachname[i].value);
	}
	setup_start();
}


function sqlite_dbtable_erzeugen() {
	db.transaction(
			function(transaction) {
				transaction.executeSql(
						'CREATE TABLE IF NOT EXISTS verkauf ' +
						' (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, ' +
						'  datum TEXT NOT NULL, ' +
						'  zeit TEXT NOT NULL, ' +
						'  verkaeufer TEXT NOT NULL, ' +
						'  artikel TEXT NOT NULL, ' +
						'  preis REAL NOT NULL, ' +
						'  anzahl REAL NOT NULL, ' +
						'  tisch REAL NOT NULL);'
				);
			}
	);
}

function errorHandler(transaction, error) {
	alert('Oops. Error was '+error.message+' (Code '+error.code+')');
	return true;
}

function dbTabelleAnzeigen() {
	vklistsumme=0.0;
	if (dbTyp==1) {
	db.transaction(
			function(transaction) {
				transaction.executeSql('SELECT id, verkaeufer, artikel, preis FROM verkauf',
				[ ],
				function (transaction, result) {
					for (var i=0; i<result.rows.length; i++) {
						var row = result.rows.item(i);
						var tr = document.createElement("tr");
						document.getElementById("verkauf").appendChild(tr);
						
						var tdId   = document.createElement("th");
						var idText = document.createTextNode(row['id']);
						tdId.appendChild(idText);
						tr.appendChild(tdId);
						
						var tdVk   = document.createElement("th");
						var VkText = document.createTextNode(row['verkaeufer']);
						tdVk.appendChild(VkText);
						tr.appendChild(tdVk);
						
						var tdAr   = document.createElement("th");
						var ArText = document.createTextNode(row['artikel']);
						tdAr.appendChild(ArText);
						tr.appendChild(tdAr);
						
						var tdPr   = document.createElement("td");
						var PrText = document.createTextNode(row['preis']);
						tdPr.appendChild(PrText);
						tr.appendChild(tdPr);
						
						vklistsumme +=parseFloat(row['preis']);
						document.getElementById("vklsumme").innerHTML=number_format (vklistsumme, 2, ",");
						}
					}
				);
				});
	}
	if (dbTyp==2) {
		var vklistsumme=0;
		var store = db.transaction('verkauf').objectStore('verkauf');
		store.openCursor().onsuccess = function(evt){
			  var cursor = evt.target.result;
			  if(cursor) {
				var tr = document.createElement("tr");
				document.getElementById("verkauf").appendChild(tr);
				
				var tdId   = document.createElement("th");
				var idText = document.createTextNode(cursor.value.id);
				tdId.appendChild(idText);
				tr.appendChild(tdId);
				
				var tdVk   = document.createElement("th");
				var VkText = document.createTextNode(cursor.value.verkaeufer);
				tdVk.appendChild(VkText);
				tr.appendChild(tdVk);
				
				var tdAr   = document.createElement("th");
				var ArText = document.createTextNode(cursor.value.artikel);
				tdAr.appendChild(ArText);
				tr.appendChild(tdAr);
				
				var tdPr   = document.createElement("td");
				var PrText = document.createTextNode(number_format (cursor.value.preis, 2, ","));
				tdPr.appendChild(PrText);
				tr.appendChild(tdPr);
				
				vklistsumme +=parseFloat(cursor.value.preis);
				document.getElementById("vklsumme").innerHTML=number_format (vklistsumme, 2, ",");
				cursor['continue']();
				}
			}; 
	}
}

function dbTabelleLoeschen() {
	if (dbTyp==1) {
	    db.transaction(function(tx) {
	    	tx.executeSql('DELETE FROM verkauf');
	        });
	}
	if (dbTyp==2) {
		var trans = db.transaction(['verkauf'], 'readwrite');
		trans.objectStore('verkauf').clear();
	}
}

function erzeuge_XML(meld) {
	xmltransfer = '<?xml version="1.0" encoding="UTF-8"?>\n' +
					'<transfer>\n<kasse>' + localStorage.getItem("KassenId") + '</kasse>\n<mail>' + localStorage.getItem("MailVerkauf") + '</mail>\n';
	if (dbTyp==1) {
	db.transaction(
			function(transaction) {
				transaction.executeSql('SELECT * FROM verkauf',
				[ ],
				function (transaction, result) {
					for (var i=0; i<result.rows.length; i++) {
						var row = result.rows.item(i);
						xmltransfer += "<verkauf>\n<id>" + row['id'] + "</id>\n<datum>" + row['datum'] + "</datum>\n<zeit>" + row['zeit'] +
									"</zeit>\n<verkaeufer>" + row['verkaeufer'] + "</verkaeufer>\n<artikel>" + row['artikel'] +
									"</artikel>\n<preis>" + row['preis'] + "</preis>\n<anzahl>" + row['anzahl'] + "</anzahl>\n<tisch>" + row['tisch'] + "</tisch>\n</verkauf>\n";
						}
					if(meld>0) {
						document.getElementById("sendentxt").innerHTML = '<br>Es sind ' + i
							+ ' Verkaufsdatensätze vorhanden<br><br>Zum versenden der Datensätze an ' 
							+  localStorage.getItem("MailVerkauf") + ' bitte auf den send-Button drücken<br>';
						}
					}
				);
			});
	}
	if (dbTyp==2) {
		var i=0;
		var store = db.transaction('verkauf').objectStore('verkauf');
		store.openCursor().onsuccess = function(evt){
			  var cursor = evt.target.result;
			  if(cursor) {
				  i++;
				  xmltransfer += "<verkauf>\n<id>" + cursor.value.id + "</id>\n<datum>" + cursor.value.datum + "</datum>\n<zeit>" + cursor.value.zeit +
							"</zeit>\n<verkaeufer>" + cursor.value.verkaeufer + "</verkaeufer>\n<artikel>" + cursor.value.artikel +
							"</artikel>\n<preis>" + cursor.value.preis + "</preis>\n<anzahl>" + cursor.value.anzahl + "</anzahl>\n<tisch>" + cursor.value.tisch + "</tisch>\n</verkauf>\n";
				  cursor['continue']();
			  }
			  /* Meldung nur beim senden ausgeben nicht beim drucken */
			  if(meld>0) {
				  document.getElementById("sendentxt").innerHTML = '<br>Es sind ' + i
						+ ' Verkaufsdatensätze vorhanden<br><br>Zum versenden der Datensätze an ' 
						+  localStorage.getItem("MailVerkauf") + ' bitte auf den send-Button drücken<br>';
				  }
		};
	}
}

function Senden_XML() {
	xmltransfer += "</transfer>";
	xmlhttp=new XMLHttpRequest();
	xmlhttp.open("POST","../kasse_send.php",false);
	xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlhttp.send("xml=" + xmltransfer);
	alert(xmlhttp.responseText);
	setup_start();
}

/* wandelt Zahlen in formatierte Ausgaben um
Beispiele
number_format (1, 2, ",") = "1,00"
number_format (1.2, null, ",") = "1,2"
number_format (1234, 0, null, ".") = "1.234"
number_format (1.23456e50, 4, ",") = "1,2346e+50"
number_format (-950.5, 2, ",", ".") = "-950,50"
number_format (-0.5, 2, ",") = "-0,50"
number_format (-0.001, 2, ",") = "0,00"
 */
function number_format (number, decimals, dec_point, thousands_sep)
{
  var exponent = "";
  var numberstr = number.toString ();
  var eindex = numberstr.indexOf ("e");
  if (eindex > -1)
  {
    exponent = numberstr.substring (eindex);
    number = parseFloat (numberstr.substring (0, eindex));
  }
  
  if (decimals != null)
  {
    var temp = Math.pow (10, decimals);
    number = Math.round (number * temp) / temp;
  }
  var sign = number < 0 ? "-" : "";
  var integer = (number > 0 ? 
      Math.floor (number) : Math.abs (Math.ceil (number))).toString ();
  
  var fractional = number.toString ().substring (integer.length + sign.length);
  dec_point = dec_point != null ? dec_point : ".";
  fractional = decimals != null && decimals > 0 || fractional.length > 1 ? 
               (dec_point + fractional.substring (1)) : "";
  if (decimals != null && decimals > 0)
  {
    for (i = fractional.length - 1, z = decimals; i < z; ++i)
      fractional += "0";
  }
  
  thousands_sep = (thousands_sep != dec_point || fractional.length == 0) ? 
                  thousands_sep : null;
  if (thousands_sep != null && thousands_sep != "")
  {
	for (var i = integer.length - 3; i > 0; i -= 3)
      integer = integer.substring (0 , i) + thousands_sep + integer.substring (i);
  }
  
  return sign + integer + fractional + exponent;
}
